#include <stdio.h>
#include "system.h"
#include "altera_avalon_pio_regs.h"
#include "sys/alt_irq.h"

/* {^荞݂̃T[rXE[` */

static void button_interrupts(void* context, alt_u32 id)
{
    int button_position;    // {^ꂽꏊ̕ۑɎgp
    button_position = IORD_ALTERA_AVALON_PIO_EDGE_CAP(BUTTON_PIO_BASE);
                            // {^PIÕGbWELv`EWX^ǂݍ
                            // ǂ̃|WṼ{^ꂽo

    IOWR_ALTERA_AVALON_PIO_DATA(LED_PIO_BASE, button_position);
                            // ꂽ{^ɑΉLED̃rbg_

    /* GbWELv`EWX^̃Zbg */
    IOWR_ALTERA_AVALON_PIO_EDGE_CAP(BUTTON_PIO_BASE, 0x0);
    button_position = 0x0;
}

/* C[` */

int main(void)
{
    printf("Interrupt test\n");

    /* PIȌ */
    // ̃{^̂݃}XNėLɂi{^S̏ꍇj
    IOWR_ALTERA_AVALON_PIO_IRQ_MASK(BUTTON_PIO_BASE, 0xF);
    
    // GbWELv`EWX^̃Zbg
    IOWR_ALTERA_AVALON_PIO_EDGE_CAP(BUTTON_PIO_BASE, 0x0);
    
    // 荞݃nh̓o^
    alt_irq_register(BUTTON_PIO_IRQ, 0, button_interrupts);
    
    while(1)
    {
        // {^̊荞݂҂
    }
    
    return 0;
}
